<template>
    <v-navigation-drawer
        v-model="isFilterBarOpen"
        absolute
        class="zi-4 filter"
        temporary
        height="800"
    >
        <v-row class="mt-16">
            <v-col
                lg="3"
                cols="2"
                class="pl-5 d-flex align-center justify-center"
            >
                <v-btn icon @click="closeFilterDrawer">
                    <v-icon>mdi-close</v-icon>
                </v-btn>
            </v-col>
            <v-col lg="9" cols="10" class="pr-10 overflow-auto selection">
                <!-- TYPE -->
                <v-col cols="12">
                    <h3>{{ $t('common.collection') }}</h3>
                    <div class="height150 overflow mt-5">
                        <v-checkbox
                            v-for="(c, col) in types"
                            :key="'col-' + col"
                            v-model="filterType"
                            :label="c.name"
                            color="badge"
                            :value="c.id + '#' + c.name"
                            hide-details
                            off-icon="mdi-checkbox-blank-circle-outline"
                            on-icon="mdi-checkbox-blank-circle"
                            class="pt-0 mt-0"
                        ></v-checkbox>
                    </div>
                </v-col>

                <v-divider />

                <!-- CATEGORY -->
                <v-col cols="12">
                    <h3>{{ $t('common.categories') }}</h3>
                    <div class="height150 overflow mt-5">
                        <v-checkbox
                            v-for="(ca, cat) in categories"
                            :key="'cat-' + cat"
                            v-model="filterCategory"
                            :label="ca.name"
                            color="badge"
                            :value="ca.id + '#' + ca.name"
                            hide-details
                            off-icon="mdi-checkbox-blank-circle-outline"
                            on-icon="mdi-checkbox-blank-circle"
                            class="pt-0 mt-0"
                        ></v-checkbox>
                    </div>
                </v-col>

                <v-divider />

                <!-- BRAND -->
                <v-col cols="12">
                    <h3>{{ $t('common.brand') }}</h3>
                    <div class="height150 overflow mt-5">
                        <v-checkbox
                            v-for="(b, bra) in brands"
                            :key="'bra-' + bra"
                            v-model="filterBrand"
                            :label="b.name"
                            color="badge"
                            :value="b.id + '#' + b.name"
                            hide-details
                            off-icon="mdi-checkbox-blank-circle-outline"
                            on-icon="mdi-checkbox-blank-circle"
                            class="pt-0 mt-0"
                        ></v-checkbox>
                    </div>
                </v-col>

                <v-divider />

                <!-- VARIANTS -->
                <v-col
                    v-for="(v, vari) in variants"
                    :key="'var-' + vari"
                    cols="12"
                >
                    <h3>{{ $t('common.' + v.name) }}</h3>
                    <div class="height150 overflow mt-5">
                        <v-checkbox
                            v-for="(o, opt) in v.options"
                            :key="'opt-' + opt"
                            v-model="filterVariant"
                            :label="o.name"
                            color="badge"
                            :value="o.id + '#' + o.name"
                            hide-details
                            off-icon="mdi-checkbox-blank-circle-outline"
                            on-icon="mdi-checkbox-blank-circle"
                            class="pt-0 mt-0"
                        ></v-checkbox>
                    </div>
                </v-col>

                <v-divider />

                <v-col cols="12">
                    <!-- <v-btn @click="check">click</v-btn> -->
                    <h3>{{ $t('common.price') }}</h3>
                    <div class="height150 overflow mt-5">
                        <client-only>
                            <vue-slider
                                v-model="filterPrice"
                                :tooltip="'none'"
                                :process-style="railStyle"
                                :min="0"
                                :max="3000"
                            ></vue-slider>
                            <p class="highlight-text">
                                {{ currencyName }} 0 - {{ currencyName
                                }}{{ filterPrice }}
                            </p>
                        </client-only>
                    </div>
                </v-col>
            </v-col>
        </v-row>
    </v-navigation-drawer>
</template>

<script lang="ts">
import { Vue, Component } from 'vue-property-decorator'
import { mapGetters } from 'vuex'

@Component({
    computed: mapGetters({
        currencyName: 'currency/getCurrencyName',
        filterDrawer: 'drawerbar/getFilterDrawer',
        getFilter: 'filter/getFilter',
        brands: 'filter/getBrands',
        types: 'filter/getTypes',
        categories: 'filter/getCategories',
        genders: 'filter/getGenders',
        variants: 'filter/getVariants',
    }),
})
export default class FilterDrawer extends Vue {
    // Data
    getFilter!: Function
    filterDrawer!: boolean
    cartDrawer!: boolean
    railStyle: {} = {
        backgroundColor: 'red',
    }

    box: String = require('~/assets/images/cartbox.png')

    // Computed
    get filterType() {
        return this.getFilter('type')
    }

    set filterType(value: []) {
        this.$store.commit('filter/setFilterTypeMutation', value)
    }

    get filterCategory() {
        return this.getFilter('category')
    }

    set filterCategory(value: []) {
        this.$store.commit('filter/setFilterCategoryMutation', value)
    }

    get filterBrand() {
        return this.getFilter('brand')
    }

    set filterBrand(value: []) {
        this.$store.commit('filter/setFilterBrandMutation', value)
    }

    get filterVariant() {
        return this.getFilter('variant')
    }

    set filterVariant(value: []) {
        this.$store.commit('filter/setFilterVariantMutation', value)
    }

    get filterPrice() {
        return this.getFilter('price')
    }

    set filterPrice(value: string) {
        this.$store.commit('filter/setFilterPriceMutation', value)
    }

    get isFilterBarOpen() {
        return this.filterDrawer
    }

    set isFilterBarOpen(value: boolean) {
        this.$store.commit('drawerbar/setFilterDrawer', value)
    }

    // Methods
    closeFilterDrawer() {
        this.$store.commit('drawerbar/setFilterDrawer', false)
    }
}
</script>
